# XXX: Tcl support seems broken
%bcond_with tcl
%bcond_without gtk

Name:           BitchX
Version:        1.1
Release:        %mkrel 9
Epoch:          1
Summary:        Textmode IRC client
License:        BSD
Group:          Networking/IRC
URL:            http://www.bitchx.org/
Source0:        http://www.bitchx.org/files/source/ircii-pana-%{version}a-final.tar.gz
Source1:        http://www.bitchx.org/files/source/tcl-c/tcl-source.tar.gz
Patch0:         BitchX-combined-debian-changes.patch
Patch1:         BitchX-ssl-certificates-support.patch
Patch2:         BitchX-static-declarations.patch
Patch3:         BitchX-gcc3.patch
Patch4:         BitchX-emacs.patch
Patch5:         BitchX-mdkconf.patch
Patch6:         BitchX-default_server.patch
Patch7:         BitchX-srcdir.patch
Patch8:         BitchX-quit-buffer-overflow.patch
BuildRequires:  mysql-devel
BuildRequires:  ncurses-devel
BuildRequires:  openssl-devel
%if %with tcl
%ifarch %{ix86} x86_64
BuildRequires:  tcl-devel
%endif
%endif
%if %with gtk
BuildRequires:  gnome-libs-devel
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
This is the bleeding edge of IRC software---the most common
functions normally done by scripts are coded into the client itself.
It contains dozens of features such as:

    * Built-in ANSI color (this is probably the biggest feature)
    * Ease of use -- dozens of useful command aliases to reduce typing
    * Built-in notify, protection, and bot lists
    * Built-in mass commands and tools
    * Extended set of DCC commands and built-in CDCC offering
    * Extended scripting functionality, including unique functions
    * Code is based on ircII-Plutonium and more recent ircII-EPiC

%if %with gtk
%package gtk
Summary:        GTK interface for BitchX
Group:          Networking/IRC
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description gtk
This is the bleeding edge of IRC software---the most common
functions normally done by scripts are coded into the client itself.
It contains dozens of features such as:

    * Built-in ANSI color (this is probably the biggest feature)
    * Ease of use -- dozens of useful command aliases to reduce typing
    * Built-in notify, protection, and bot lists
    * Built-in mass commands and tools
    * Extended set of DCC commands and built-in CDCC offering
    * Extended scripting functionality, including unique functions
    * Code is based on ircII-Plutonium and more recent ircII-EPiC

This package contains the GTK interface for BitchX.
%endif

%prep
%setup -q -n BitchX
%if %with tcl
%setup -q -n BitchX/source -T -D -a 1
%endif
%setup -q -n BitchX -T -D
%{_bindir}/find . -name '*.orig' | %{_bindir}/xargs -t %{__rm}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p0
%patch5 -p0
%patch6 -p1
%patch7 -p1
%patch8 -p1

%{__perl} -pi -e 's/\r$//g' doc/misc/pandur.ans

%build
export CFLAGS="%{optflags} -fPIC -fno-strict-aliasing"
export CONFIGURE_TOP=..
%if %with gtk
%{__mkdir_p} obj-gtk
cd obj-gtk
%{configure2_5x} \
%if %with tcl
    --with-tcl \
%else
     --without-tcl \
%endif
    --with-gtk \
    --enable-sound \
    --with-non-blocking=posix \
    --with-default-server=irc.freenode.net:6667 \
    --with-plugins=nicklist \
    --with-ssl \
    --enable-ipv6
%{make}
cd ..
%endif

%{__mkdir_p} obj
cd obj
%{configure2_5x} \
%if %with tcl
    --with-tcl \
%else
     --without-tcl \
%endif
    --with-non-blocking=posix \
    --with-default-server=irc.freenode.net:6667 \
    --with-plugins \
    --with-ssl \
    --enable-ipv6
%{make}
cd ..

%install
%{__rm} -rf %{buildroot}

%if %with gtk
(cd obj-gtk && %{makeinstall})
%endif

(cd obj && %{makeinstall})

%{__install} -m 644 BitchX.help %{buildroot}%{_libdir}/bx
%{__install} -m 644 BitchX.ircnames %{buildroot}%{_libdir}/bx
%{__install} -m 644 BitchX.quit %{buildroot}%{_libdir}/bx
%{__install} -m 644 BitchX.reasons %{buildroot}%{_libdir}/bx
%{__install} -m 755 obj/source/wserv %{buildroot}%{_bindir}

# fix up binary symlinks
%if %with gtk
%{__ln_s}f gtkBitchX-%{version}-final %{buildroot}%{_bindir}/gtkBitchX
%endif
%{__ln_s}f BitchX-%{version}-final %{buildroot}%{_bindir}/BitchX

# make symlink for wserv
%{__ln_s}f ../..%{_libdir}/bx/wserv %{buildroot}%{_bindir}/wserv

(cd %{buildroot}%{_mandir}/man1 && %{_bindir}/bunzip2 *.bz2)

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(0644,root,root,0755)
%doc COMPILE-PROBLEMS Changelog INSTALL IPv6-support MEMORIAL README README-1.1-FINAL doc/
%attr(0755,root,root) %{_bindir}/BitchX
%attr(0755,root,root) %{_bindir}/BitchX-%{version}-final
%attr(0755,root,root) %{_bindir}/scr-bx
%attr(0755,root,root) %{_bindir}/wserv
%{_libdir}/bx/BitchX.help
%{_libdir}/bx/BitchX.ircnames
%{_libdir}/bx/BitchX.kick
%{_libdir}/bx/BitchX.quit
%{_libdir}/bx/BitchX.reasons
%{_libdir}/bx/help/
%{_libdir}/bx/plugins/BitchX.hints
%attr(0755,root,root) %{_libdir}/bx/plugins/*.so
%if %with gtk
%exclude %{_libdir}/bx/plugins/nicklist.so
%endif
%{_libdir}/bx/script/
%{_libdir}/bx/translation/
%attr(0755,root,root) %{_libdir}/bx/wserv
%{_mandir}/man1/BitchX.1*

%if %with gtk
%files gtk
%defattr(0644,root,root,0755)
%attr(0755,root,root) %{_bindir}/gtkBitchX
%attr(0755,root,root) %{_bindir}/gtkBitchX-%{version}-final
%attr(0755,root,root) %{_libdir}/bx/plugins/nicklist.so
%endif


%changelog
* Fri Sep 14 2007 David Walluck <walluck@mandriva.org> 1.1-9mdv2008.0
+ Revision: 85486
- change back to default dir (avoids using symlink)

* Tue Sep 11 2007 David Walluck <walluck@mandriva.org> 1:1.1-8mdv2008.0
+ Revision: 84298
- rebuild for 2008
- fix build
- major spec cleanup
- remove unused patches
- apply 3 patches from Ubuntu (modified for version 1.1a)
- new patch for srcdir
- new patch for /quit overflow
- add optional tcl build (broken)
- add gtk package
- Import BitchX



* Thu Jun 15 2006 Lenny Cartier <lenny@mandriva.com> 1:1.1-7mdv2007.0
- rebuild

* Fri Dec 02 2005 Marcel Pol <mpol@mandriva.org> 1.1-6mdk
- P15: default server is irc.freenode.org

* Mon Nov 14 2005 Oden Eriksson <oeriksson@mandriva.com> 1.1-5mdk
- rebuilt against openssl-0.9.8a

* Sat May 14 2005 Christiaan Welvaart <cjw@daneel.dyndns.org> 1.1-4mdk
- Patch14: fix build with gcc 4.0

* Fri May 06 2005 Per Øyvind Karlsen <pkarlsen@mandriva.com> 1.1-3mdk
- compile with -fPIC (fixes build on x86_64)

* Sat Jan 01 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 1.1-2mdk
- add ipv6 support (by Larry Nguyen's request)

* Mon Jun 14 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 1.1-1mdk
- 1.1-final
- fix gcc-3.4 build (P13)
- compile with optimizations
- drop P11 & P12 (fixed upstream)
- drop prefix tag
- don't wipe out buildroot in %%prep
- cleanups
- drop patches that were no longer applied

* Mon Jun 16 2003 Vincent Danen <vdanen@mandrakesoft.com> 1.0-0.c19.7mdk
- security patch (CAN-2003-0334)

* Sun Jun 15 2003 Stefan van der Eijk <stefan@eijk.nu> 1.0-0.c19.6mdk
- BuildRequires

* Thu Jun 12 2003 Guillaume Cottenceau <gc@mandrakesoft.com> 1.0-0.c19.5mdk
- gcc-3.3

* Mon Nov 04 2002 Ha Quôc-VViêt <viet@mandrakesoft.com> 1.0-0.c19.4mdk
- Patch10: fixes a few missing prototypes (string.h for memcpy, _getlong, etc)

* Wed May 29 2002 Stefan van der Eijk <stefan@eijk.nu> 1.0-0.c19.3mdk
- BuildRequires

* Fri May 24 2002 Warly <warly@mandrakesoft.com> 1.0-0.c19.2mdk
- remove version replying

* Mon May 13 2002 Warly <warly@mandrakesoft.com> 1.0-0.c19.1mdk
- new version

* Thu Mar 28 2002 Warly <warly@mandrakesoft.com> 1.0-0.c18.1mdk
- new version

* Thu Feb 28 2002 Geoffrey Lee <snailtalk@mandrakesoft.com> 1.0-0.c17.13mdk
- Don't make BitchX depend on a versionless tcl.

* Wed Feb 27 2002 dam's <damien@mandrakesoft.com> 1.0-0.c17.12mdk
- added tcl require

* Tue Oct 23 2001 dam's <damien@mandrakesoft.com> 1.0-0.c17.11mdk
- patch 7 (no_europa) to remove europa plugin.
- get rid of MySQL buildrequire

* Wed Aug 22 2001 dam's <damien@mandrakesoft.com> 1.0-0.c17.10mdk
- added provides

* Mon Aug 13 2001 dam's <damien@mandrakesoft.com> 1.0-0.c17.9mdk
- rebuilt

* Fri Jul 13 2001 Christian Belisle <cbelisle@mandrakesoft.com> 1.0-0.c17.8mdk
- Recompile with new MySQL-shared
- s/Copyright/License

* Wed Apr 18 2001 Francis Galiegue <fg@mandrakesoft.com> 1.0-0.c17.7mdk
- Disable tcl for ia64 as well
- Fixed BuildRequires so that tcl is not required for archs that don't need it

* Wed Mar  7 2001 dam's <damien@mandrakesoft.com> 1.0-0.c17.6mdk
- moved help to /usr/share/doc

* Sun Jan 21 2001 Warly <warly@mandrakesoft.com> 1.0-0.c17.5mdk
- recompile with new MySQL-shared

* Tue Dec 19 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.0-0.c17.4mdk
- BuildRequires: MySQL-devel
- Remove the alpha patch, no needed anymore.

* Mon Dec 18 2000 dam's <damien@mandrakesoft.com> 1.0-0.c17.3mdk
- corrected copyright.

* Fri Dec 15 2000 dam's <damien@mandrakesoft.com> 1.0-0.c17.2mdk
- corrected copyright.

* Thu Dec 14 2000 Vincent Danen <vdanen@mandrakesoft.com> 1.0-0.c17.1mdk
- 1.0c17
- build with plugins
- security patch to prevent buffer overflow
- removed previous format patch (included now)

* Mon Nov  6 2000 dam's <damien@mandrakesoft.com> 75p3-18mdk
- cosmetik changes.

* Tue Aug 08 2000 Frederic Lepied <flepied@mandrakesoft.com> 75p3-17mdk
- automatically added BuildRequires

* Mon Jul 24 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 75p3-16mdk
- BM

* Sun Jul 09 2000 David BAUDENS <baudens@mandrakesoft.com> 75p3-15mdk
- BuildRequires: rpm >= 3.0.5

* Sun Jul  9 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 75p3-14mdk
- Active HUMBLE.

* Sun Jul  9 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 75p3-13mdk
- Don't build with tcl on ppc either - ld also segfaults. Doh.
- macros clean-up.

* Thu Jul  6 2000 dam's <damien@mandrakesoft.com> 75p3-12mdk
- Patch to avoid segfault when inviting with %%s.

* Wed Mar 22 2000 dam's <damien@mandrakesoft.com> 75p3-11mdk
- Release

* Fri Jan 14 2000 Francis Galiegue <francis@mandrakesoft.com>
- Don't build with tcl on sparc either - ld also segfaults. Doh.

* Fri Jan 14 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 75p3-9mdk
- Patch to work on alpha (sucky !!!).
- Add Mandrak3 in /version.
- Bind some emacs keys.
- Don't compile with tcl on alpha (ld segfault !!!!).
- WANT_NOTIFY_BITCHX_COM off
- WANT_HEBREW ON.
- DEFAULT_OPERMODE "swfc"
- update descriptions.

* Tue Nov 23 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- Empty pocket lint (rpmlint that is)
	- strip
	- new group "Applications/Internet"

* Sun Oct 31 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- Enable SMP build

* Thu Aug 05 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- Added character translations from ircii (test this lots please!)

* Tue Aug 03 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- Add some defines so /help works

* Sun Aug  1 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>

- Mailed original to RedHat =P.
- Insert Manpages.
- Insert Bitchx.* in %%{prefix}/lib/bx/
- Inert description in spec.
- Insert doc.

* Fri Jul  9 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- patch config.h for pidentd+fm
- Mailed original to Microsoft =P
- enabled Hades look cause blue is boreing

* Fri Jul  9 1999 Bernhard Rosenkraenzer <bero@mandrakesoft.de>
- Add Obsoletes: ircii
- Fix up symlink /usr/bin/BitchX
- suggest the broken 1mdk package for inclusion in Microsoft Linux ;)

* Fri Jul  9 1999 Bernhard Rosenkraenzer <bero@mandrakesoft.de>
- initial RPM
